#define BOOST_TEST_MODULE "testcase for TypedFilename class"
#define BOOST_TEST_DYN_LINK
#include "common.hpp"

#include <boost/test/unit_test.hpp>

#include <harkio2/TypedFilename.hpp>
using namespace harkio2;

BOOST_AUTO_TEST_CASE(constructors_test)
{
    TypedFilename f1(u8"foo", FileType::FLOAT);

    BOOST_CHECK_EQUAL(f1.GetName(), u8"foo");
    BOOST_CHECK_EQUAL(f1.GetType(), FileType::FLOAT);

    TypedFilename f2(u8"珈琲", FileType::WAVE);

    BOOST_CHECK_EQUAL(f2.GetName(), u8"珈琲");
    BOOST_CHECK_EQUAL(f2.GetType(), FileType::WAVE);
}

BOOST_AUTO_TEST_CASE(operators_test)
{
    TypedFilename f1(u8"foo", FileType::FLOAT);
    TypedFilename f2(u8"foo", FileType::FLOAT);
    TypedFilename f3(u8"bar", FileType::FLOAT);
    TypedFilename f4(u8"foo", FileType::WAVE);

    BOOST_CHECK(f1 == f2);
    BOOST_CHECK(f1 != f3);
    BOOST_CHECK(f1 != f4);
}

